/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Hyperion Pattern.
 Hyperion Pattern is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/


#ifndef _hyp_ker_interfaces_h_
#define _hyp_ker_interfaces_h_


#ifndef hyp_KERNEL_INSIDE
#error Inclusion not allowed (include hyp.kernel.h instead)
#endif


//-------------------------------------------------------------------------
//{04FE4A80-B650-11d4-A083-0080AD97951B}
hyp_DEFINE_GUID(IID_hypIUnknown, 
0x4fe4a80, 0xb650, 0x11d4, 0xa0, 0x83, 0x0, 0x80, 0xad, 0x97, 0x95, 0x1b);

/*!
\ingroup PrimaryInterface
Fondamental interface of the Hyperion components.
*/
struct IUnknown
{
	virtual com_result QueryInterface(const hypIID&,void**) =0;
	virtual t_ulong AddRef() =0;
	virtual t_ulong Release() =0;
};
//-------------------------------------------------------------------------
// {04FE4A81-B650-11d4-A083-0080AD97951B}
hyp_DEFINE_IID(IID_hypIClassFactory, 
0x4fe4a81, 0xb650, 0x11d4, 0xa0, 0x83, 0x0, 0x80, 0xad, 0x97, 0x95, 0x1b);

/*!
\ingroup PrimaryInterface
Fondamental interface for a component factory.
*/
struct IClassFactory :
public IUnknown
{
	virtual com_result CreateInstance(IUnknown*,const hypIID&,void**) =0;
	virtual com_result LockServer(bool) =0;
};
//-------------------------------------------------------------------------


#endif