/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Hyperion Pattern.
 Hyperion Pattern is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$

 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/

/*! \file hyp.initguid.h
Include this file to define global GUID. For example,
\code
//file.h
//the guid is declared
#include"hyp.kernel.h"

// {FB954D60-05D0-11d5-A083-0080AD97951B}
hyp_DEFINE_GUID(CLSID_Test, 
0xfb954d60, 0x5d0, 0x11d5, 0xa0, 0x83, 0x0, 0x80, 0xad, 0x97, 0x95, 0x1b);

//file.cpp
//the guid is defined
#include"hyp.kernel.h"
#include"hyp.initguid.h"
// {FB954D60-05D0-11d5-A083-0080AD97951B}
hyp_DEFINE_GUID(CLSID_Test, 
0xfb954d60, 0x5d0, 0x11d5, 0xa0, 0x83, 0x0, 0x80, 0xad, 0x97, 0x95, 0x1b);
\endcode
\note No \c #ifdef and \c #endif macros for this file.
*/



#undef hyp_DEFINE_GUID

/*!
Defines a GUID.
*/
#define hyp_DEFINE_GUID( name , data1 , data2 , data3 , \
						data4_0 , data4_1 , data4_2 , data4_3 , data4_4 , data4_5 , data4_6 , data4_7) \
	extern "C" const hyp_ADD_NAMESPACE_HYPKERNEL(CGuid) name ( data1 , data2 , data3 , \
						data4_0 , data4_1 , data4_2 , data4_3 , data4_4 , data4_5 , data4_6 , data4_7 )


