/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Hyperion Pattern.
 Hyperion Pattern is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/



#ifndef _hyp_ker_def_h_
#define _hyp_ker_def_h_

/*! \defgroup HypPatternDef
*/
//@{
//! Is used to insert some components in the <i>Hyperion Pattern</i> namespace.
#define hyp_NAMESPACE_BEGIN_HYPKERNEL                       \
	hyp_NAMESPACE_BEGIN_HYP hyp_NAMESPACE_BEGIN(ker)
//! See \ref hyp_NAMESPACE_BEGIN_HYPKERNEL
#define hyp_NAMESPACE_END_HYPKERNEL                         \
	hyp_NAMESPACE_END(ker) hyp_NAMESPACE_END_HYP

//! Macro trick. Is not actually used.
#define hyp_ADD_NAMESPACE_HYPKERNEL( arg )                  \
	::hyp::ker::##arg

/*!
Active the macro \c hyp_ker_EXPORT_DLL to export the compounds of the <i>Hyperion Pattern</i>.
So this macro is only used for the compilation of the library.
*/
#ifdef hyp_ker_EXPORT_DLL
	#define hyp_ker_DLL hyp_EXPORT_DLL
#else
	#define hyp_ker_DLL hyp_IMPORT_DLL
#endif

//@}

#endif