/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Hyperion Pattern.
 Hyperion Pattern is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/

#if !defined _hyp_dir_h_
#define _hyp_dir_h_

#ifndef hyp_KERNEL_CORE_INSIDE
#error Inclusion not allowed (include hyp.kernel.core.h instead)
#endif



class hyp_ker_DLL CDir {
#ifdef hyp_WIN32
	std::string m_Path;
	HANDLE m_H;
	WIN32_FIND_DATA m_FD;
#endif
	std::string m_Pattern;
	std::string GetFullName(const std::string&);
public:
	CDir();
	virtual ~CDir();
	std::string Search();
	void Rewind(const std::string& ="*");
	void Open(const std::string&,bool =false);
	bool IsSubDir();
	bool IsInDir(const std::string&,bool =false);
	void CreateFile(const std::string&) const;
	void DeleteFile(const std::string&) const;
	std::string GetPath() const;
};


#endif