/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Hyperion Pattern.
 Hyperion Pattern is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/

#if !defined(_hyp_guid_h_)
#define _hyp_guid_h_

#ifndef hyp_KERNEL_CORE_INSIDE
#error Inclusion not allowed (include hyp.kernel.core.h instead)
#endif


#undef hyp_DEFINE_GUID
/*!
\name Utility Macro
\ingroup Guid
Helps to declare a GUID.
@{
*/
#define hyp_DEFINE_GUID( Name , Data1 , Data2 , Data3 ,\
	Data4_0 , Data4_1 , Data4_2 , Data4_3 , Data4_4 , Data4_5 , Data4_6 , Data4_7) \
extern "C" const hyp_ADD_NAMESPACE_HYPKERNEL(CGuid) Name

#define hyp_DEFINE_IID hyp_DEFINE_GUID
#define hyp_DEFINE_CLSID hyp_DEFINE_GUID
//@}

class hyp_ker_DLL CGuid
{
	/*! Structure which has a size of 128 bits.*/
	struct _guid
	{
		t_ulong Data1;
		t_ushort Data2;
		t_ushort Data3;
		t_uchar Data4[8];
	} m_Guid;
	

public:
	CGuid(t_ulong,
		t_ushort,t_ushort,
		t_uchar,t_uchar,t_uchar,t_uchar,t_uchar,t_uchar,t_uchar,t_uchar);
	CGuid();
	CGuid(const std::string&);

	inline CGuid& operator=(const CGuid& Guid) {
		memcpy(&m_Guid,&Guid.m_Guid,sizeof(m_Guid));
		return *this;
	}

	inline bool operator==(const CGuid& Guid) const {
		return memcmp(&m_Guid,&Guid.m_Guid,sizeof(m_Guid))==0 ? true : false;
	}

	inline bool operator!=(const CGuid& Guid) const {
		return !(*this==Guid);
	}	
	
	std::string ToString(void) const;
};

inline std::ostream& operator<<(std::ostream& Stream,const CGuid& GUID) {
	Stream<<GUID.ToString();
	return Stream;
}

/*!
\name Alias
\ingroup Guid
@{
*/
typedef CGuid hypCLSID;
typedef CGuid hypIID;
typedef CGuid hypGUID;
//@}


#endif
