/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Hyperion Pattern.
 Hyperion Pattern is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/


#if !defined(_hyp_registry_h_)
#define _hyp_registry_h_

#ifndef hyp_KERNEL_CORE_INSIDE
#error Inclusion not allowed (include hyp.kernel.core.h instead)
#endif


class CStdRegistryFile;

class hyp_ker_DLL CStdRegistry :
protected CDir
{
public:
	CStdRegistry(const std::string&);
	virtual ~CStdRegistry();

	CStdRegistryFile* GetRegistryFile(const std::string&);
	inline CStdRegistryFile* GetRegistryFile() const {
		hyp_ASSERT(m_pCurrentRegistryFile);
		return m_pCurrentRegistryFile;
	};

	CStdRegistryFile* CreateRegistryFile(const std::string&);
	void DeleteRegistryFile(const std::string&);

	/*!
	\param Name Name of the file
	\return true if the file is in the registry
	*/
	inline bool IsInRegistry(const std::string& Name) {
		return IsInDir(Name);
	}

	/*!
	\return path of the CStdRegistry object
	*/
	inline std::string GetPathofRegistry() const {
		return GetPath();
	}

private:
	CStdRegistryFile* m_pCurrentRegistryFile;
};



#endif
