/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Hyperion Pattern.
 Hyperion Pattern is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/



#if !defined(_hyp_registryfile_h_)
#define _hyp_registryfile_h_

#ifndef hyp_KERNEL_CORE_INSIDE
#error Inclusion not allowed (include hyp.kernel.core.h instead)
#endif



class CStdRegistry;


class hyp_ker_DLL CStdRegistryFile  
{
	bool GetPosValue(const std::string&,
					std::string::size_type&,
					std::string::size_type&) const;
	bool GetPosKey(const std::string&,
					std::string::size_type&,
					std::string::size_type&) const;
	void DeletePartofStream(const std::string&,
		const std::string::size_type&,
		const std::string::size_type&);
	
	CStdRegistry* m_pRegistry;	//!< Registry which is associated to the object
	std::string m_Name;	//!< File name which is wrapped by the object
	std::string m_FileString;	//!< Contents of the file

public:
	
	CStdRegistryFile(const std::string&,CStdRegistry*);
	virtual ~CStdRegistryFile();

	std::string GetValue(const std::string&) const;
	void SetValue(const std::string&,const std::string&);	
	void SetKey(const std::string&);
	void DeleteKey(const std::string&);
};



#endif