/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Hyperion Pattern.
 Hyperion Pattern is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/



#ifndef _hyp_ker_regserver_impl_h_
#define _hyp_ker_regserver_impl_h_

#ifndef hyp_KERNEL_CORE_INSIDE
#error Inclusion not allowed (include hyp.kernel.core.h instead)
#endif



#ifdef hyp_WIN32

class hyp_ker_DLL CWin32ImplRegistry :
public IImplRegistry
{
	HKEY m_hRootKey;

	bool RecursiveDeleteKey(HKEY,const char*);
	bool SetKeyAndValueNameAndValue(const char*,const char*,const char*,const char*);
	bool GetHandleKey(const char*,const char*,HKEY*);
	std::string GetAbsoluteKey(const std::string&,const std::string&);

public:
	CWin32ImplRegistry();
	~CWin32ImplRegistry();

	virtual void SetKey(const std::string&,
		const std::string&);
	
	virtual void SetValueNameAndValue(const std::string&,
		const std::string&,
		const std::string&,
		const std::string&);

	virtual void DeleteKey(const std::string&,
		const std::string&);
	
	/*
	virtual void SetKeyRoot(const std::string&);
	*/

	virtual std::string GetValueFromValueName(const std::string&,
		const std::string&,
		const std::string&);
};

#endif

class hyp_ker_DLL CStdImplRegistry :
public IImplRegistry
{
public:
	CStdImplRegistry();

	virtual void SetKey(const std::string&,const std::string&);
	
	virtual void SetValueNameAndValue(const std::string&,
		const std::string&,
		const std::string&,
		const std::string&);

	virtual void DeleteKey(const std::string&, const std::string&);
		
	/*
	virtual void SetKeyRoot(const std::string&);
	*/

	virtual std::string GetValueFromValueName(const std::string&,
		const std::string&,
		const std::string&);
};

#endif