/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Hyperion Pattern.
 Hyperion Pattern is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/


#ifndef _hyp_ker_result_h_
#define _hyp_ker_result_h_


#ifndef hyp_KERNEL_CORE_INSIDE
#error Inclusion not allowed (include hyp.kernel.core.h instead)
#endif


/*!
\ingroup ComException
Enumerates all the standard error codes.
Gives the descriptions of the results from com_result.
\dontinclude hyp.ker.exception.cpp
\skip CComResultDescriptor()
\until }
*/
enum com_result {
	com_ok,
	com_notified,
	com_false,
	com_assertion_failed,
	com_unexpected,
	com_not_impl,
	com_no_interface,
	com_bad_arguments,
	com_no_available,
	com_must_no_call,
	com_no_aggregation,
	com_class_not_available,
	com_out_of_memory,
	com_invalid_arg,
	com_logic_in_arguments,
	com_initialisation_data,
	com_bad_internal_data,
	com_directxfile,
	com_ios,
	com_envvar,
	com_file_missing,
	com_winregistry
};

/*!
\ingroup ComException
Returns true if the result code is not listed as an error code.
*/
inline bool Succeeded(com_result Result) {
	return (Result==com_ok || Result==com_notified);
}

/*!
\ingroup ComException
Returns true if the result code is listed as an an error code.
*/
inline bool Failed(com_result Result) {
	return !Succeeded(Result);	
}

#endif