/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Hyperion Pattern.
 Hyperion Pattern is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/

#ifndef _hyp_ker_extern_h_
#define _hyp_ker_extern_h_

/*! \file hyp.kernel.core.h
Uses to include all the compounds which are necessary to manage the basic roots of the component
technology.
\todo include profiler
*/

/*!
This macro must be defined to include the referenced files. Indeed, at the begin of each files, there is:
\code
#ifndef hyp_KERNEL_CORE_INSIDE
#error Inclusion not allowed (include hyp.kernel.core.h instead)
#endif
\endcode
*/
#define hyp_KERNEL_CORE_INSIDE




//FIXTODO
//'identifier' : class 'type' needs to have dll-interface to be used by clients of class 'type2'
//The specified base class was not declared with the __declspec(dllexport) keyword.
#pragma warning( disable: 4251 ) 

//non-DLL-interface classkey 'identifier' used as base for DLL-interface classkey 'identifier'
//An exported class was derived from a class that was not exported.
#pragma warning( disable: 4275 )

//WARNING 4786 : identifier was truncated to '255' characters in the debug information.
#pragma warning( disable: 4786 )

#include"hyp.def.h"
#include"hyp.type.h"
#include"hyp.ker.def.h"

hyp_NAMESPACE_BEGIN_HYPKERNEL
	
	#include"hyp.ker.trace.h"
	#include"hyp.ker.assert.h"

	#include"hyp.ker.global.h"

	#include"hyp.ker.result.h"
	#include"hyp.ker.exception.h"

	#include"hyp.ker.time.h"
	#include"hyp.ker.dir.h"
	//#include"hyp.ker.profiler.h"
	#include"hyp.ker.command.h"
	#include"hyp.ker.dll.h"
	#include"hyp.ker.guid.h"

	#include"hyp.ker.regserver_utility.h"
	#include"hyp.ker.registry.h"
	#include"hyp.ker.registryfile.h"
	#include"hyp.ker.regserver_impl.h"

hyp_NAMESPACE_END_HYPKERNEL

#endif