/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Hyperion Pattern.
 Hyperion Pattern is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/


/*! \file hyp.kernel.std.h
Brings together the header files that are necessary to create easly Hyperion components.
*/


#ifndef _hyp_std_kernel_h_
#define _hyp_std_kernel_h_

/*!
Avoids wrong file inclusion. See \ref hyp_KERNEL_CORE_INSIDE.
*/
#define hyp_KERNEL_STD_INSIDE

#ifdef hypstd_TRACE_ON
/*!
Trace operation for the standard library. Activated with the compilation of
the standard compounds by the macro \c hypstd_TRACE_ON.
*/
#define hypstd_TRACE( Args )                       \
	hyp_TRACE_BEGIN();                             \
	hyp_TRACE_DO( ("Trace from std module") );     \
	hyp_TRACE_DO( Args );                          \
	hyp_TRACE_END();
#else
#define hypstd_TRACE( Args )
#endif

hyp_NAMESPACE_BEGIN_HYPKERNEL

	#include"hyp.std.non_delegating_unknwn.h"
	#include"hyp.std.unknwn.h"
	#include"hyp.std.factorydata.h"
	#include"hyp.std.factory.h"

hyp_NAMESPACE_END_HYPKERNEL


#endif