/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Hyperion Pattern.
 Hyperion Pattern is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/

#ifndef _hypstd_non_delegating_unknwn_h_
#define _hypstd_non_delegating_unknwn_h_

#ifndef hyp_KERNEL_STD_INSIDE
#error Inclusion not allowed (include hyp.kernel.std.h instead)
#endif

/*!
Interface used to implement the standard components. Deals with the notion
of component aggregation.
*/
class INondelegatingUnknown
{
public:
	virtual com_result NondelegatingQueryInterface(const hypIID&,void**)=0;
	virtual t_ulong NondelegatingAddRef()=0;
	virtual t_ulong NondelegatingRelease()=0;
};



#endif