/*
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
 Hyperion Pattern.
 Hyperion Pattern is a part of the Hyperion Project.
----------------------------------------------------------
 Copyright (c) 2001 Pierre Rebours.

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 
 See hyp.license.txt file for more information about the license.
 
 Web: http://lagrandeporte.multimania.com/hyperion
 Email: pierre_rebours@yahoo.com
----------------------------------------------------------
 CVS
 $Log$
\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
*/



#include"hyp.type.h"

hyp_NAMESPACE_BEGIN_HYP


hyp_ker_DLL t_int64 GetInt64(t_uint High,t_uint Low)
{
	return static_cast<t_int64>( (High << 32) | Low);
}

hyp_ker_DLL t_uint GetHighInt64(t_int64 Int)
{
	return static_cast<unsigned int>(Int>>32);
}

hyp_ker_DLL t_uint GetLowInt64(t_int64 Int)
{
	return static_cast<unsigned int>(Int);
}

/*!
Owner stream for the 64 bits integers.
\todo numeric_limits::max_exponent10 ? doesn't work...
*/
hyp_ker_DLL std::ostream& operator<<(std::ostream& Stream,const t_int64& Int) {
	if(GetHighInt64(Int)!=0)
		Stream<<GetHighInt64(Int)<<std::setw(10)<<std::setfill('0');
	Stream<<GetLowInt64(Int);
	return Stream;
}

hyp_NAMESPACE_END_HYP



